/*************************************************/
/*                                               */
/*             */
/*                                               */
/*            */
/*                                               */
/*                  */
/*                                               */
/*************************************************/

/*********************************************************/
/*                                                       */
/*         ,        */
/*         ,                    */
/*                   */
/*                        */
/*                                                       */
/*********************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>

static FILE* f,*out;
static int buf[256];
const char* str[2]={"\t@\t","\t!\t"};

int isprintrus(int c)
{
 if(isprint(c)) return -1;
 if(c==163 || c==179) return -1;
 if(c<=255 && c>=192) return -1;
 return 0;
}

int main(int argc,char* argv[])
{
 int n, i;
 char *s1;
 int j=0,k=0,l=0,m=0;

 if(argc==1)
 {
  FILE* x; int i;
  if((x=fopen("koi8.table","w"))==NULL) return 1;

  for(i=0; i<256; i++)
  {
   int si=isprintrus(i) ? 0:1;
   fprintf(x,"  %c    %d  %s\n",i,i,str[si]);
  }
  fclose(x);
  return -1;
 }

 if((f=fopen(argv[1],"r"))==NULL){ perror("    .\n"); return 2;}

  n=strlen(argv[1]);
  s1=(char*) malloc(n+2);
  memcpy(s1,argv[1],n);
  s1[n]='.';
  s1[n+1]='r';
  s1[n+2]='\0';

 if((out=fopen(s1,"w"))==NULL){ perror("    .\n"); return 2;}

 for(i=0; i<256; i++) buf[i++]=0;

 while(!feof(f))
 {
  int c=getc(f);
  buf[c]++;
 }

 for(i=0; i<256; i++)
 {
  if(buf[i])
  {
   j++;
   if(isalnum(i)) k++; if(i==163 || i==179 || i<=255 && i>=192) k++;
   if(isprintrus(i)) l++;
  }
 }

 fprintf(out,"   %d.\n \n",j);
 fprintf(out,"   %d.\n",k);
 fprintf(out,"  %d.\n %d.\n",l,j-l);

 for(i=0; i<256; i++)
 if(buf[i])
 {
  int si=isprintrus(i) ? 0:1;
  if(i!='\n') fprintf(out,"\t%c\t\t%d\t=%d\t%s\n",i,i,buf[i],str[si]);
  else fprintf(out,"\t\\n\t\t%d\t=%d\t%s\n",i,buf[i],str[si]);
 }

 fclose(f);
 fclose(out);
 return 0;
}
